<?php
function theme_enqueue_styles() {
    $parent_style = 'parent-style';

    wp_enqueue_style( 'child-style', get_stylesheet_directory_uri() . '/style.css', array( $parent_style ));
    wp_enqueue_style( 'custom-style', get_stylesheet_directory_uri() . '/shTSQL.css', false);
}
add_action( 'wp_enqueue_scripts', 'theme_enqueue_styles' );

/***************   TSQL highlighter   *************/
// SyntaxHighlighter Evolved doesn't do anything until early in the "init" hook, so best to wait until after that
add_action( 'init', 'syntaxhighlighter_TSQL_regscript' );
 
// Tell SyntaxHighlighter Evolved about this new language/brush
add_filter( 'syntaxhighlighter_brushes', 'syntaxhighlighter_TSQL_addlang' );
 
// Register the brush file with WordPress
function syntaxhighlighter_TSQL_regscript() {
    wp_enqueue_script( 'syntaxhighlighter-brush-TSQL', get_stylesheet_directory_uri().'/shBrushTSQL.js', array('syntaxhighlighter-core'), '20150902' );    
}
 
// Filter SyntaxHighlighter Evolved's language array
function syntaxhighlighter_TSQL_addlang( $brushes ) {
    $brushes['TSQL'] = 'TSQL';
    $brushes['tsql'] = 'tsql';
 
    return $brushes;
}
/*****************************************************/
?>
