IF OBJECT_ID('tempdb..#systemReservedTypes')	IS NOT NULL DROP TABLE #systemReservedTypes
IF OBJECT_ID('tempdb..#systemReserved')			IS NOT NULL DROP TABLE #systemReserved
GO

CREATE TABLE #systemReservedTypes(
	type_desc SYSNAME
	, color CHAR(7))

CREATE TABLE #systemReserved(
	type_desc SYSNAME
	, name SYSNAME)


INSERT INTO #systemReservedTypes VALUES 
  (N'Aggregate'							, '#FF00FF')
, (N'Configuration'						, '#FF00FF')
, (N'Cursor'							, '#FF00FF')
, (N'Date_Time'							, '#FF00FF')
, (N'Logical'							, '#FF00FF')
, (N'Mathematical'						, '#FF00FF')
, (N'Metadata'							, '#FF00FF')
, (N'Other'								, '#FF00FF')
, (N'Hierarchy'							, '#FF00FF')
, (N'Rowset'							, '#0000FF')
, (N'Rowset_Pink'						, '#FF00FF')
, (N'Security'							, '#FF00FF')
, (N'String'							, '#FF00FF')
, (N'System_statistical'				, '#FF00FF')
, (N'Text_Image'						, '#FF00FF')
, (N'SET_Options'						, '#0000FF')
, (N'System_Data_Types'					, '#0000FF')
, (N'TSQL_keyword_grey'					, '#808080')
, (N'TSQL_keyword_pink'					, '#FF00FF')
, (N'TSQL_keyword_blue'					, '#0000FF')
, (N'TSQL_keyword_green'				, '#008000')
, (N'AGGREGATE_FUNCTION'				, '#000000')
, (N'CLR_SCALAR_FUNCTION'				, '#000000')
, (N'CLR_STORED_PROCEDURE'				, '#800000')
, (N'EXTENDED_STORED_PROCEDURE'			, '#800000')
, (N'SQL_INLINE_TABLE_VALUED_FUNCTION'	, '#008000')
, (N'SQL_SCALAR_FUNCTION'				, '#000000')
, (N'SQL_STORED_PROCEDURE'				, '#800000')
, (N'SQL_TABLE_VALUED_FUNCTION'			, '#008000')
, (N'SYSTEM_TABLE'						, '#000000')
, (N'VIEW'								, '#008000')


INSERT INTO #systemReserved VALUES 
  ('Aggregate', 'Avg')
, ('Aggregate', 'Binary_checksum')
, ('Aggregate', 'Checksum')
, ('Aggregate', 'Checksum_agg')
, ('Aggregate', 'Count')
, ('Aggregate', 'Count_big')
, ('Aggregate', 'Grouping')
, ('Aggregate', 'Grouping_Id')
, ('Aggregate', 'Max')
, ('Aggregate', 'Min')
, ('Aggregate', 'Stdev')
, ('Aggregate', 'Stdevp')
, ('Aggregate', 'Sum')
, ('Aggregate', 'Var')
, ('Aggregate', 'Varp')

INSERT INTO #systemReserved VALUES 
  ('Configuration', 'ConnectionProperty')
, ('Configuration', '@@Datefirst')
, ('Configuration', '@@Dbts')
, ('Configuration', '@@Langid')
, ('Configuration', '@@Language')
, ('Configuration', '@@Lock_Timeout')
, ('Configuration', '@@Max_Connections')
, ('Configuration', '@@Max_Precision')
, ('Configuration', '@@Nestlevel')
, ('Configuration', '@@Options')
, ('Configuration', '@@Remserver')
, ('Configuration', '@@Servername')
, ('Configuration', '@@Servicename')
, ('Configuration', '@@Spid')
, ('Configuration', '@@Textsize')
, ('Configuration', '@@Version')

INSERT INTO #systemReserved VALUES 
 ('Cursor', '@@Cursor_Rows')
, ('Cursor', 'Cursor_Status')
, ('Cursor', '@@Fetch_Status')

INSERT INTO #systemReserved VALUES 
  ('Date_Time', 'Current_Timestamp')
, ('Date_Time', 'Dateadd')
, ('Date_Time', 'Datediff')
, ('Date_Time', 'Datename')
, ('Date_Time', 'Datepart')
, ('Date_Time', 'Day')
, ('Date_Time', 'Getdate')
, ('Date_Time', 'Getutcdate')
, ('Date_Time', 'Isdate')
, ('Date_Time', 'Month')
, ('Date_Time', 'Sysdatetime')
, ('Date_Time', 'Sysdatetimeoffset')
, ('Date_Time', 'Sysutcdatetime')
, ('Date_Time', 'Switchoffset')
, ('Date_Time', 'Todatetimeoffset')
, ('Date_Time', 'Year')

INSERT INTO #systemReserved VALUES 
 ('Logical', 'CHOOSE')
, ('Logical', 'IIF ')

INSERT INTO #systemReserved VALUES 
 ('Mathematical', 'Abs')
, ('Mathematical', 'Acos')
, ('Mathematical', 'Asin')
, ('Mathematical', 'Atan')
, ('Mathematical', 'Atn2')
, ('Mathematical', 'Ceiling')
, ('Mathematical', 'Cos')
, ('Mathematical', 'Cot')
, ('Mathematical', 'Degrees')
, ('Mathematical', 'Exp')
, ('Mathematical', 'Floor')
, ('Mathematical', 'Log')
, ('Mathematical', 'Log10')
, ('Mathematical', 'Pi')
, ('Mathematical', 'Power')
, ('Mathematical', 'Radians')
, ('Mathematical', 'Rand')
, ('Mathematical', 'Round')
, ('Mathematical', 'Sign')
, ('Mathematical', 'Sin')
, ('Mathematical', 'Sqrt')
, ('Mathematical', 'Square')
, ('Mathematical', 'Tan')

INSERT INTO #systemReserved VALUES 
 ('Metadata', 'Col_Length')
, ('Metadata', 'Col_Name')
, ('Metadata', 'Columnproperty')
, ('Metadata', 'Databaseproperty')
, ('Metadata', 'Databasepropertyex')
, ('Metadata', 'Db_Id')
, ('Metadata', 'Db_Name')
, ('Metadata', 'File_Id')
, ('Metadata', 'File_Name')
, ('Metadata', 'Filegroup_Id')
, ('Metadata', 'Filegroup_Name')
, ('Metadata', 'Filegroupproperty')
, ('Metadata', 'Fileproperty')
, ('Metadata', 'Fulltextcatalogproperty')
, ('Metadata', 'Fulltextserviceproperty')
, ('Metadata', 'Index_Col')
, ('Metadata', 'Indexkey_Property')
, ('Metadata', 'Indexproperty')
, ('Metadata', 'Object_Id')
, ('Metadata', 'Object_Name')
, ('Metadata', 'Objectproperty')
, ('Metadata', 'Objectpropertyex')
, ('Metadata', '@@Procid')
, ('Metadata', 'Sql_Variant_Property')
, ('Metadata', 'Typeproperty')
, ('Metadata', 'Change_tracking_current_version')
, ('Metadata', 'Change_Tracking_Is_Column_In_Mask')
, ('Metadata', 'Change_Tracking_Cleanup_Version')

INSERT INTO #systemReserved VALUES 
  ('Other', 'App_Name')
, ('Other', 'Cast')
, ('Other', 'Coalesce')
, ('Other', 'Collationproperty')	
, ('Other', 'Columns_Updated')
, ('Other', 'Convert')
, ('Other', 'Current_User')
, ('Other', 'Datalength')
, ('Other', '@@Error')
, ('Other', 'Formatmessage')
, ('Other', 'Getansinull')
, ('Other', 'Host_Id')
, ('Other', 'Host_Name')
, ('Other', 'Ident_Current')
, ('Other', 'Ident_Incr')
, ('Other', 'Ident_Seed')
, ('Other', '@@Identity')
, ('Other', 'Isnull')
, ('Other', 'Isnumeric')
, ('Other', 'Newid')
, ('Other', 'Nullif')
, ('Other', 'Parsename')
, ('Other', 'Permissions')
, ('Other', '@@Rowcount')
, ('Other', 'Rowcount_Big')
, ('Other', 'Scope_Identity')
, ('Other', 'Serverproperty')
, ('Other', 'Sessionproperty')
, ('Other', 'Session_User')
, ('Other', 'Stats_Date')
, ('Other', 'System_User')
, ('Other', '@@Trancount')
, ('Other', 'Update')
, ('Other', 'User_Name')

INSERT INTO #systemReserved VALUES 
  ('Hierarchy', 'GetRoot')
, ('Hierarchy', 'GetDescendant')
, ('Hierarchy', 'IsDescendantOf')
, ('Hierarchy', 'GetLevel')
, ('Hierarchy', 'GetAncestor')
, ('Hierarchy', 'GetReparentedValue')
, ('Hierarchy', 'ToString')

INSERT INTO #systemReserved VALUES 
  ('Rowset', 'Containstable')
, ('Rowset', 'Freetexttable')
, ('Rowset', 'Opendatasource')
, ('Rowset', 'Openquery')
, ('Rowset', 'Openrowset')
, ('Rowset', 'Openxml')
, ('Rowset_Pink', 'CHANGETABLE')

INSERT INTO #systemReserved VALUES 
  ('Security', 'Has_Dbaccess')
, ('Security', 'original_db_name')
, ('Security', 'Is_Member')
, ('Security', 'Is_Srvrolemember')
, ('Security', 'Suser_Sid')
, ('Security', 'Suser_name')
, ('Security', 'Suser_Sname')
, ('Security', 'User')
, ('Security', 'User_Id')
, ('Security', 'User_Name')

INSERT INTO #systemReserved VALUES 
  ('String', 'Ascii')
, ('String', 'Charindex')
, ('String', 'Difference')
, ('String', 'Len')
, ('String', 'Lower')
, ('String', 'Ltrim')
, ('String', 'Patindex')
, ('String', 'Quotename')
, ('String', 'Replace')
, ('String', 'Replicate')
, ('String', 'Reverse')
, ('String', 'Rtrim')
, ('String', 'Soundex')
, ('String', 'Space')
, ('String', 'Str')
, ('String', 'Stuff')
, ('String', 'Substring')
, ('String', 'Unicode')
, ('String', 'Upper')

INSERT INTO #systemReserved VALUES 
  ('System_statistical', '@@Connections')
, ('System_statistical', '@@Cpu_Busy')
, ('System_statistical', '@@Idle')
, ('System_statistical', '@@Io_Busy')
, ('System_statistical', '@@Pack_Received')
, ('System_statistical', '@@Pack_Sent')
, ('System_statistical', '@@Packet_Errors')
, ('System_statistical', '@@Timeticks')
, ('System_statistical', '@@Total_Errors')
, ('System_statistical', '@@Total_Read')
, ('System_statistical', '@@Total_Write')

INSERT INTO #systemReserved VALUES 
  ('Text_Image', 'Patindex')
, ('Text_Image', 'Textptr')
, ('Text_Image', 'Textvalid')

INSERT INTO #systemReserved VALUES 
  ('SET_Options', 'DATEFIRST')
, ('SET_Options', 'DATEFORMAT')
, ('SET_Options', 'DEADLOCK_PRIORITY')
, ('SET_Options', 'LOCK_TIMEOUT')
, ('SET_Options', 'CONCAT_NULL_YIELDS_NULL')
, ('SET_Options', 'CURSOR_CLOSE_ON_COMMIT')
, ('SET_Options', 'FIPS_FLAGGER')
, ('SET_Options', 'IDENTITY_INSERT')
, ('SET_Options', 'LANGUAGE')
, ('SET_Options', 'OFFSETS')
, ('SET_Options', 'QUOTED_IDENTIFIER')
, ('SET_Options', 'ARITHABORT')
, ('SET_Options', 'ARITHIGNORE')
, ('SET_Options', 'FMTONLY')
, ('SET_Options', 'NOCOUNT')
, ('SET_Options', 'NOEXEC')
, ('SET_Options', 'NUMERIC_ROUNDABORT')
, ('SET_Options', 'PARSEONLY')
, ('SET_Options', 'QUERY_GOVERNOR_COST_LIMIT')
, ('SET_Options', 'ROWCOUNT')
, ('SET_Options', 'TEXTSIZE')
, ('SET_Options', 'ANSI_DEFAULTS')
, ('SET_Options', 'ANSI_NULL_DFLT_OFF')
, ('SET_Options', 'ANSI_NULL_DFLT_ON')
, ('SET_Options', 'ANSI_NULLS')
, ('SET_Options', 'ANSI_PADDING')
, ('SET_Options', 'ANSI_WARNINGS')
, ('SET_Options', 'FORCEPLAN')
, ('SET_Options', 'SHOWPLAN_ALL')
, ('SET_Options', 'SHOWPLAN_TEXT')
, ('SET_Options', 'SHOWPLAN_XML')
, ('SET_Options', 'STATISTICS IO')
, ('SET_Options', 'STATISTICS XML')
, ('SET_Options', 'STATISTICS PROFILE')
, ('SET_Options', 'STATISTICS TIME')
, ('SET_Options', 'IMPLICIT_TRANSACTIONS')
, ('SET_Options', 'REMOTE_PROC_TRANSACTIONS')
, ('SET_Options', 'TRANSACTION ISOLATION LEVEL')
, ('SET_Options', 'XACT_ABORT')

INSERT INTO #systemReserved 
SELECT 'System_Data_Types', name
FROM sys.types

INSERT INTO #systemReserved 
SELECT * FROM (VALUES 
-- Grey
  ('TSQL_keyword_grey', 'ALL')
, ('TSQL_keyword_grey', 'AND')
, ('TSQL_keyword_grey', 'ANY')
, ('TSQL_keyword_grey', 'BETWEEN')
, ('TSQL_keyword_grey', 'CROSS')
, ('TSQL_keyword_grey', 'EXISTS')
, ('TSQL_keyword_grey', 'IN')
, ('TSQL_keyword_grey', 'INNER')
, ('TSQL_keyword_grey', 'IS')
, ('TSQL_keyword_grey', 'JOIN')
, ('TSQL_keyword_grey', 'LEFT')
, ('TSQL_keyword_grey', 'LIKE')
, ('TSQL_keyword_grey', 'NOT')
, ('TSQL_keyword_grey', 'NULL')
, ('TSQL_keyword_grey', 'OR')
, ('TSQL_keyword_grey', 'OUTER')
, ('TSQL_keyword_grey', 'PIVOT')
, ('TSQL_keyword_grey', 'RIGHT')
, ('TSQL_keyword_grey', 'SOME')
, ('TSQL_keyword_grey', 'UNPIVOT') 
-- Pink
, ('TSQL_keyword_pink', 'COALESCE')
, ('TSQL_keyword_pink', 'COLLATE')
, ('TSQL_keyword_pink', 'CONTAINS')
, ('TSQL_keyword_pink', 'CONVERT')
, ('TSQL_keyword_pink', 'CURRENT_TIME')
, ('TSQL_keyword_pink', 'CURRENT_TIMESTAMP')
, ('TSQL_keyword_pink', 'CURRENT_USER')
, ('TSQL_keyword_pink', 'NULLIF')
, ('TSQL_keyword_pink', 'SESSION_USER')
, ('TSQL_keyword_pink', 'SYSTEM_USER')
, ('TSQL_keyword_pink', 'TRY_CONVERT')
, ('TSQL_keyword_pink', 'TSEQUAL')
, ('TSQL_keyword_pink', 'UPDATE') 
-- Blue
, ('TSQL_keyword_blue', 'ADD')
, ('TSQL_keyword_blue', 'ALTER')
, ('TSQL_keyword_blue', 'AS')
, ('TSQL_keyword_blue', 'ASC')
, ('TSQL_keyword_blue', 'AUTHORIZATION')
, ('TSQL_keyword_blue', 'BACKUP')
, ('TSQL_keyword_blue', 'BEGIN')
, ('TSQL_keyword_blue', 'BREAK')
, ('TSQL_keyword_blue', 'BROWSE')
, ('TSQL_keyword_blue', 'BULK')
, ('TSQL_keyword_blue', 'BY')
, ('TSQL_keyword_blue', 'CASCADE')
, ('TSQL_keyword_blue', 'CASE')
, ('TSQL_keyword_blue', 'CHECK')
, ('TSQL_keyword_blue', 'CHECKPOINT')
, ('TSQL_keyword_blue', 'CLOSE')
, ('TSQL_keyword_blue', 'CLUSTERED')
, ('TSQL_keyword_blue', 'COLUMN')
, ('TSQL_keyword_blue', 'COMMIT')
, ('TSQL_keyword_blue', 'COMPUTE')
, ('TSQL_keyword_blue', 'CONSTRAINT')
, ('TSQL_keyword_blue', 'CONTAINSTABLE')
, ('TSQL_keyword_blue', 'CONTINUE')
, ('TSQL_keyword_blue', 'CREATE')
, ('TSQL_keyword_blue', 'CURRENT')
, ('TSQL_keyword_blue', 'CURRENT_DATE')
, ('TSQL_keyword_blue', 'CURSOR')
, ('TSQL_keyword_blue', 'DATABASE')
, ('TSQL_keyword_blue', 'DBCC')
, ('TSQL_keyword_blue', 'DEALLOCATE')
, ('TSQL_keyword_blue', 'DECLARE')
, ('TSQL_keyword_blue', 'DEFAULT')
, ('TSQL_keyword_blue', 'DEFAULT_DATABASE')
, ('TSQL_keyword_blue', 'DELETE')
, ('TSQL_keyword_blue', 'DENY')
, ('TSQL_keyword_blue', 'DESC')
, ('TSQL_keyword_blue', 'DISABLE')
, ('TSQL_keyword_blue', 'DISK')
, ('TSQL_keyword_blue', 'DISTINCT')
, ('TSQL_keyword_blue', 'DISTRIBUTED')
, ('TSQL_keyword_blue', 'DOUBLE')
, ('TSQL_keyword_blue', 'DROP')
, ('TSQL_keyword_blue', 'DUMMY')
, ('TSQL_keyword_blue', 'DUMP')
, ('TSQL_keyword_blue', 'ELSE')
, ('TSQL_keyword_blue', 'END')
, ('TSQL_keyword_blue', 'ERRLVL')
, ('TSQL_keyword_blue', 'ESCAPE')
, ('TSQL_keyword_blue', 'EXCEPT')
, ('TSQL_keyword_blue', 'EXEC')
, ('TSQL_keyword_blue', 'EXECUTE')
, ('TSQL_keyword_blue', 'EXIT')
, ('TSQL_keyword_blue', 'EXTERNAL')
, ('TSQL_keyword_blue', 'FETCH')
, ('TSQL_keyword_blue', 'FILE')
, ('TSQL_keyword_blue', 'FILLFACTOR')
, ('TSQL_keyword_blue', 'FOR')
, ('TSQL_keyword_blue', 'FOREIGN')
, ('TSQL_keyword_blue', 'FREETEXT')
, ('TSQL_keyword_blue', 'FREETEXTTABLE')
, ('TSQL_keyword_blue', 'FROM')
, ('TSQL_keyword_blue', 'FULL')
, ('TSQL_keyword_blue', 'FUNCTION')
, ('TSQL_keyword_blue', 'GO')
, ('TSQL_keyword_blue', 'GOTO')
, ('TSQL_keyword_blue', 'GRANT')
, ('TSQL_keyword_blue', 'GROUP')
, ('TSQL_keyword_blue', 'HAVING')
, ('TSQL_keyword_blue', 'HOLDLOCK')
, ('TSQL_keyword_blue', 'IDENTITY')
, ('TSQL_keyword_blue', 'IDENTITY_INSERT')
, ('TSQL_keyword_blue', 'IDENTITYCOL')
, ('TSQL_keyword_blue', 'IF')
, ('TSQL_keyword_blue', 'INDEX')
, ('TSQL_keyword_blue', 'INSERT')
, ('TSQL_keyword_blue', 'INTERSECT')
, ('TSQL_keyword_blue', 'INTO')
, ('TSQL_keyword_blue', 'KEY')
, ('TSQL_keyword_blue', 'KILL')
, ('TSQL_keyword_blue', 'LINENO')
, ('TSQL_keyword_blue', 'LOAD')
, ('TSQL_keyword_blue', 'LOGIN')
, ('TSQL_keyword_blue', 'MERGE')
, ('TSQL_keyword_blue', 'MOVE')
, ('TSQL_keyword_blue', 'NATIONAL')
, ('TSQL_keyword_blue', 'NOCHECK')
, ('TSQL_keyword_blue', 'NONCLUSTERED')
, ('TSQL_keyword_blue', 'OF')
, ('TSQL_keyword_blue', 'OFF')
, ('TSQL_keyword_blue', 'OFFSETS')
, ('TSQL_keyword_blue', 'ON')
, ('TSQL_keyword_blue', 'OPEN')
, ('TSQL_keyword_blue', 'OPENDATASOURCE')
, ('TSQL_keyword_blue', 'OPENQUERY')
, ('TSQL_keyword_blue', 'OPENROWSET')
, ('TSQL_keyword_blue', 'OPENXML')
, ('TSQL_keyword_blue', 'OPTION')
, ('TSQL_keyword_blue', 'ORDER')
, ('TSQL_keyword_blue', 'OVER')
, ('TSQL_keyword_blue', 'PASSWORD')
, ('TSQL_keyword_blue', 'PATH')
, ('TSQL_keyword_blue', 'PERCENT')
, ('TSQL_keyword_blue', 'PLAN')
, ('TSQL_keyword_blue', 'PRECISION')
, ('TSQL_keyword_blue', 'PRIMARY')
, ('TSQL_keyword_blue', 'PRINT')
, ('TSQL_keyword_blue', 'PROC')
, ('TSQL_keyword_blue', 'PROCEDURE')
, ('TSQL_keyword_blue', 'PUBLIC')
, ('TSQL_keyword_blue', 'RAISERROR')
, ('TSQL_keyword_blue', 'READ')
, ('TSQL_keyword_blue', 'READTEXT')
, ('TSQL_keyword_blue', 'RECONFIGURE')
, ('TSQL_keyword_blue', 'RECOVERY')
, ('TSQL_keyword_blue', 'REFERENCES')
, ('TSQL_keyword_blue', 'REPLICATION')
, ('TSQL_keyword_blue', 'RESTORE')
, ('TSQL_keyword_blue', 'RESTRICT')
, ('TSQL_keyword_blue', 'RETURN')
, ('TSQL_keyword_blue', 'REVERT')
, ('TSQL_keyword_blue', 'REVOKE')
, ('TSQL_keyword_blue', 'ROLE')
, ('TSQL_keyword_blue', 'ROLLBACK')
, ('TSQL_keyword_blue', 'ROWCOUNT')
, ('TSQL_keyword_blue', 'ROWGUIDCOL')
, ('TSQL_keyword_blue', 'RULE')
, ('TSQL_keyword_blue', 'SAVE')
, ('TSQL_keyword_blue', 'SCHEMA')
, ('TSQL_keyword_blue', 'SECURITYAUDIT')
, ('TSQL_keyword_blue', 'SELECT')
, ('TSQL_keyword_blue', 'SEMANTICKEYPHRASETABLE')
, ('TSQL_keyword_blue', 'SEMANTICSIMILARITYDETAILSTABLE')
, ('TSQL_keyword_blue', 'SEMANTICSIMILARITYTABLE')
, ('TSQL_keyword_blue', 'SET')
, ('TSQL_keyword_blue', 'SETUSER')
, ('TSQL_keyword_blue', 'SHUTDOWN')
, ('TSQL_keyword_blue', 'STATISTICS')
, ('TSQL_keyword_blue', 'TABLE')
, ('TSQL_keyword_blue', 'TABLESAMPLE')
, ('TSQL_keyword_blue', 'TEXTSIZE')
, ('TSQL_keyword_blue', 'THEN')
, ('TSQL_keyword_blue', 'TO')
, ('TSQL_keyword_blue', 'TOP')
, ('TSQL_keyword_blue', 'TRAN')
, ('TSQL_keyword_blue', 'TRANSACTION')
, ('TSQL_keyword_blue', 'TRIGGER')
, ('TSQL_keyword_blue', 'TRUNCATE')
, ('TSQL_keyword_blue', 'TRUSTWORTHY')
, ('TSQL_keyword_blue', 'UNION')
, ('TSQL_keyword_blue', 'UNIQUE')
, ('TSQL_keyword_blue', 'UPDATETEXT')
, ('TSQL_keyword_blue', 'USE')
, ('TSQL_keyword_blue', 'USER')
, ('TSQL_keyword_blue', 'VALUES')
, ('TSQL_keyword_blue', 'VARYING')
, ('TSQL_keyword_blue', 'VIEW')
, ('TSQL_keyword_blue', 'WAITFOR')
, ('TSQL_keyword_blue', 'WHEN')
, ('TSQL_keyword_blue', 'WHERE')
, ('TSQL_keyword_blue', 'WHILE')
, ('TSQL_keyword_blue', 'WITH')
, ('TSQL_keyword_blue', 'WITHIN GROUP')
, ('TSQL_keyword_blue', 'WRITETEXT')
, ('TSQL_keyword_blue', 'master')
-- Green
, ('TSQL_keyword_green', 'STATS')

) AS t(type_desc, name)
WHERE name NOT IN (SELECT name FROM #systemReserved)


INSERT INTO #systemReserved 
SELECT type_desc
		, name 
FROM sys.all_objects AS t1
WHERE type_desc NOT IN (
N'DEFAULT_CONSTRAINT'
, N'INTERNAL_TABLE'
, N'SERVICE_QUEUE'
, N'USER_TABLE'
, N'PRIMARY_KEY_CONSTRAINT'
)
AND is_ms_shipped = 1

-- Now put everything together
SELECT type_desc
		, N'.syntaxhighlighter .' + type_desc + N'{color : ' + c.color + N' !important;}' AS css

		, N'{ regex: new RegExp(this.getKeywords(' + type_desc + N'), ''gmi''),	css: ''' + type_desc + N''' },' AS js_css

		, N'var ' + c.type_desc + N' = ''' +
		 STUFF((SELECT ' ' + name FROM #systemReserved AS t
					WHERE t.type_desc = c.type_desc
					ORDER BY name
					FOR XML PATH('')), 1,1,'')
			+ N''';' AS js_var

FROM #systemReservedTypes AS c


